class MenuList extends Controller<MenuList> {
  ArrayList<AnchorImage> aImages; 
  float pos, npos;
  int itemHeight = 100;
  int scrollerLength = 40;
  PGraphics menu;
  boolean updateMenu;
  int totalHeight=0;
  int w, h;

  MenuList(ControlP5 c, String theName, int theWidth, int theHeight, ArrayList<AnchorImage> _aImages) {
    super( c, theName, 0, 0, theWidth, theHeight );
    c.register( this );
    w = theWidth;
    aImages = _aImages;
    updateHeight(theWidth);
    menu = createGraphics(getWidth(), getHeight() );
    setView(new ControllerView<MenuList>() {
      public void display(PGraphics pg, MenuList t ) {
        if (updateMenu) {
          updateMenu();
        }
        if (inside() ) {
          menu.beginDraw();
          //int len = -(itemHeight * items.size()) + getHeight();
          //int ty = int(map(pos, len, 0, getHeight() - scrollerLength - 2, 2 ) );
          // menu.background(0, 128);
          // menu.rect(0, 0, getWidth(), 50);
          // menu.rect(getWidth()-4, ty, 4, scrollerLength );
          menu.endDraw();
        }
        pg.image(menu, 0, 0);
      }
    }
    );
    updateMenu();
  }

  void updateSource(ArrayList<AnchorImage> newSource) {
    aImages = new ArrayList(newSource);
    updateHeight(200);
    updateMenu();
  }

  void updateMenu() {
    int len = -(totalHeight) + getHeight();
    npos = constrain(npos, len, 0);
    if (totalHeight < getHeight() ) {
      pos = 0;
    } else {
      pos += (npos - pos) * 0.1;
    }
    menu.beginDraw();
    menu.pushMatrix();
    menu.translate( 0, pos );
    menu.pushMatrix();
    menu.noStroke();
    menu.background(240);
    for (AnchorImage a : aImages) {
      int newH = a.thumbH;
      menu.image(a.img, 0, 0, w, newH);
      if (a.selected) {
        menu.noFill();
        menu.stroke(255, 255, 155);
        menu.strokeWeight(4);
        menu.rect(2, 2, w-4, newH-4);
      }
      for (int i = 0; i < a.joints.size(); i++) {
        Joint j = a.joints.get(i);
        menu.noStroke();
        menu.fill(j.c);
        menu.ellipse(20, 20+i*30, 20, 20);
      }
      menu.translate(0, newH);
    }
    menu.popMatrix();
    menu.popMatrix();
    menu.endDraw();
    updateMenu = abs(npos-pos)>0.01 ? true:false;
  }

  int returnIndex( int y ) {
    int index = 0;
    int b2;
    int b1=0;
    for (AnchorImage a : aImages) {
      index = aImages.indexOf(a);
      b2 = b1 + a.thumbH;
      if ( y > b1 && y < b2 ) {
        break;
      } else {
        index = -1;
        b1 = b2;
      }
    }
    return index;
  }

  public void onClick() {
    int index = returnIndex( int(getPointer().y() - pos) ) ;
    if (index > -1 &&  aImages.size() > 0) {
      AnchorImage s = aImages.get(index);
      if ( s.selected ) {
        s.selected=false;
        GLOBAL_selectedAnchorImage=null;
      } else {
        for (AnchorImage a : aImages) {
          a.selected=false;
        }
        s.selected=true;
        GLOBAL_selectedAnchorImage = s;
      }
    }
    println( index);
    GLOBAL_render = false;
    updateMenu = true;
  }

  void deselectAll() {
    for (AnchorImage a : aImages) {
      a.selected=false;
    }
    GLOBAL_selectedAnchorImage=null;
  }

  public void onDrag() {
    npos += getPointer().dy() * 2;
    updateMenu = true;
  } 

  public void onScroll(int n) {
    npos -= ( n * 64 );
    updateMenu = true;
  }

  void updateHeight(int w) {
    totalHeight=0;
    for (AnchorImage a : aImages) {
      int thumbH = a.fitImageWidth(w);
      a.thumbH = thumbH;
      totalHeight+=thumbH;
    }
  }
}

public void controlEvent(ControlEvent theEvent) {
  // println("got a menu event from item : "+theEvent);
}
