import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import org.apache.commons.io.FilenameUtils; 
import java.util.*; 
import controlP5.*; 
import java.util.Random; 
import java.util.Arrays; 
import java.util.List; 
import org.apache.commons.lang3.RandomStringUtils; 

import org.apache.commons.io.comparator.*; 
import org.apache.commons.io.*; 
import org.apache.commons.io.monitor.*; 
import org.apache.commons.io.filefilter.*; 
import org.apache.commons.io.input.*; 
import org.apache.commons.io.serialization.*; 
import org.apache.commons.io.output.*; 
import org.apache.commons.lang3.arch.*; 
import org.apache.commons.lang3.*; 
import org.apache.commons.lang3.builder.*; 
import org.apache.commons.lang3.concurrent.*; 
import org.apache.commons.lang3.event.*; 
import org.apache.commons.lang3.exception.*; 
import org.apache.commons.lang3.mutable.*; 
import org.apache.commons.lang3.reflect.*; 
import org.apache.commons.lang3.text.*; 
import org.apache.commons.lang3.text.translate.*; 
import org.apache.commons.lang3.time.*; 
import org.apache.commons.lang3.tuple.*; 
import org.apache.commons.lang3.math.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class Variations_RC5 extends PApplet {









ControlP5 cp5;
MenuList browser;
CustomList setBrowser;
JointList jointList;
PGraphics renderPanel, buffer;
//PGraphics2D controlPanel;
PFont font, iconFont;
Random randomGenerator;

ArrayList<AnchorImage> empty;
ArrayList<ImageSet> imageSets = new ArrayList<ImageSet>();
ArrayList<Joint> joints =  new ArrayList<Joint>();
ArrayList<Integer> dOrder =  new ArrayList<Integer>();
AnchorImage GLOBAL_selectedAnchorImage = null;
int GLOBAL_selectedSet=-1;
int GLOBAL_joint=-1;
boolean GLOBAL_render = false;
int GLOBAL_startRecord = -1;
String saveFolder;

int view_w; 
int view_h;
int buffer_w; 
int buffer_h;

public void settings() {

  view_w = 1080;
  view_h = 1080;
  buffer_w = 1080;
  buffer_h = 1080;

  size(view_w+700, view_h);
  // smooth(4);
}

public void setup() {
  buffer =  createGraphics(buffer_w, buffer_h);
  renderPanel = createGraphics(view_w, view_h);
  renderPanel.ellipseMode(CENTER);
  renderPanel.beginDraw();
  renderPanel.background(255);
  renderPanel.endDraw();
  //renderPanel.smooth(4);
  background(240);
  cp5 = new ControlP5( this );
  font = createFont("SourceCodePro-Regular.ttf", 18, true);
  iconFont = createFont("icomoon.ttf", 21, true);
  cp5.setFont(new ControlFont(iconFont));

  setBrowser = new CustomList( cp5, "setBrowser", 300, height-50, imageSets );
  setBrowser.setPosition(0, 50);

  buildButtons();

  //ImageSet def = new ImageSet( loadImagesFolder("legs"), "legs" );
  //def.absFolderName = "D:\\Dropbox\\Processing_new\\Variations_RC5\\legs";
  //imageSets.add( def );
  //dOrder.add(imageSets.size()-1);

  //def = new ImageSet( loadImagesFolder("body"), "body" );
  //def.absFolderName = "D:\\Dropbox\\Processing_new\\Variations_RC5\\body";
  //imageSets.add( def );
  //dOrder.add(imageSets.size()-1);

  //def = new ImageSet( loadImagesFolder("head"), "head" );
  //def.absFolderName = "D:\\Dropbox\\Processing_new\\Variations_RC5\\head";
  //imageSets.add( def );
  //dOrder.add(imageSets.size()-1);

  updateDrawOrder();


  empty = new ArrayList<AnchorImage>();
  browser = new MenuList( cp5, "browser", 200, height-50, empty );
  browser.setPosition(300, 50);

  addJointList();
  jointList = new JointList( cp5, "jointlist", 200, height-100, joints );
  jointList.setPosition(width-200, 50);
}

public void mouseReleased() {
  if (GLOBAL_joint>-1 && GLOBAL_selectedAnchorImage != null) {
    if (mouseX > 500 && mouseX < width-200) {
      Joint j = joints.get(GLOBAL_joint);
      Joint newJoint; 
      int jid = GLOBAL_selectedAnchorImage.hasJoint(j.id);
      if  ( jid > -1 ) {
        newJoint = GLOBAL_selectedAnchorImage.joints.get(jid);
        newJoint.setXY(mouseX-500, mouseY);
      } else {
        newJoint= new Joint(j.id, j.c);
        newJoint.setXY(mouseX-500, mouseY);
        GLOBAL_selectedAnchorImage.joints.add(newJoint);
      }
      browser.updateMenu();
    }
  }
}

public void draw() {
  setBrowser.updateMenu();
  background(240);
  String txt_fps = String.format(getClass().getName()+ "  [fps %6.2f]", frameRate);
  surface.setTitle(txt_fps);
  renderPanel.beginDraw();
  renderPanel.background(255);
  if (GLOBAL_selectedAnchorImage != null && !GLOBAL_render ) {
    renderPanel.image(GLOBAL_selectedAnchorImage.img, 0, 0);
    for (Joint j : GLOBAL_selectedAnchorImage.joints) {
      renderPanel.noFill();
      renderPanel.stroke(j.c);
      renderPanel.strokeWeight(4);
      renderPanel.ellipse(j.x, j.y, 50, 50);
    }
  } else if (GLOBAL_startRecord >=0 ) {
    // for (ArrayList<AnchorImage> pmap : combs) {
    ArrayList<AnchorImage> pmap = combs.get(GLOBAL_startRecord);
    build(pmap);
    buffer.save(saveFolder+"/"+RandomStringUtils.randomNumeric(8)+".png");
    GLOBAL_startRecord--;
    renderPanel.fill(0);
    renderPanel.textSize(32);
    renderPanel.textAlign(CENTER, CENTER);
    renderPanel.text(GLOBAL_startRecord+" remaining", view_w/2, view_h/2);
  } else if (recRandom && saveFolderExist) {
    preview();
    renderPanel.image(buffer, 0, 0, view_w, view_h);
    buffer.save(saveFolder+"/"+RandomStringUtils.randomNumeric(8)+".png");
  } else {
    renderPanel.image(buffer, 0, 0, view_w, view_h);
  }
  renderPanel.endDraw();
  image(renderPanel, 500, 0, view_w, view_h);
}
class MenuList extends Controller<MenuList> {
  ArrayList<AnchorImage> aImages; 
  float pos, npos;
  int itemHeight = 100;
  int scrollerLength = 40;
  PGraphics menu;
  boolean updateMenu;
  int totalHeight=0;
  int w, h;

  MenuList(ControlP5 c, String theName, int theWidth, int theHeight, ArrayList<AnchorImage> _aImages) {
    super( c, theName, 0, 0, theWidth, theHeight );
    c.register( this );
    w = theWidth;
    aImages = _aImages;
    updateHeight(theWidth);
    menu = createGraphics(getWidth(), getHeight() );
    setView(new ControllerView<MenuList>() {
      public void display(PGraphics pg, MenuList t ) {
        if (updateMenu) {
          updateMenu();
        }
        if (inside() ) {
          menu.beginDraw();
          //int len = -(itemHeight * items.size()) + getHeight();
          //int ty = int(map(pos, len, 0, getHeight() - scrollerLength - 2, 2 ) );
          // menu.background(0, 128);
          // menu.rect(0, 0, getWidth(), 50);
          // menu.rect(getWidth()-4, ty, 4, scrollerLength );
          menu.endDraw();
        }
        pg.image(menu, 0, 0);
      }
    }
    );
    updateMenu();
  }

  public void updateSource(ArrayList<AnchorImage> newSource) {
    aImages = new ArrayList(newSource);
    updateHeight(200);
    updateMenu();
  }

  public void updateMenu() {
    int len = -(totalHeight) + getHeight();
    npos = constrain(npos, len, 0);
    if (totalHeight < getHeight() ) {
      pos = 0;
    } else {
      pos += (npos - pos) * 0.1f;
    }
    menu.beginDraw();
    menu.pushMatrix();
    menu.translate( 0, pos );
    menu.pushMatrix();
    menu.noStroke();
    menu.background(240);
    for (AnchorImage a : aImages) {
      int newH = a.thumbH;
      menu.image(a.img, 0, 0, w, newH);
      if (a.selected) {
        menu.noFill();
        menu.stroke(255, 255, 155);
        menu.strokeWeight(4);
        menu.rect(2, 2, w-4, newH-4);
      }
      for (int i = 0; i < a.joints.size(); i++) {
        Joint j = a.joints.get(i);
        menu.noStroke();
        menu.fill(j.c);
        menu.ellipse(20, 20+i*30, 20, 20);
      }
      menu.translate(0, newH);
    }
    menu.popMatrix();
    menu.popMatrix();
    menu.endDraw();
    updateMenu = abs(npos-pos)>0.01f ? true:false;
  }

  public int returnIndex( int y ) {
    int index = 0;
    int b2;
    int b1=0;
    for (AnchorImage a : aImages) {
      index = aImages.indexOf(a);
      b2 = b1 + a.thumbH;
      if ( y > b1 && y < b2 ) {
        break;
      } else {
        index = -1;
        b1 = b2;
      }
    }
    return index;
  }

  public void onClick() {
    int index = returnIndex( PApplet.parseInt(getPointer().y() - pos) ) ;
    if (index > -1 &&  aImages.size() > 0) {
      AnchorImage s = aImages.get(index);
      if ( s.selected ) {
        s.selected=false;
        GLOBAL_selectedAnchorImage=null;
      } else {
        for (AnchorImage a : aImages) {
          a.selected=false;
        }
        s.selected=true;
        GLOBAL_selectedAnchorImage = s;
      }
    }
    println( index);
    GLOBAL_render = false;
    updateMenu = true;
  }

  public void deselectAll() {
    for (AnchorImage a : aImages) {
      a.selected=false;
    }
    GLOBAL_selectedAnchorImage=null;
  }

  public void onDrag() {
    npos += getPointer().dy() * 2;
    updateMenu = true;
  } 

  public void onScroll(int n) {
    npos -= ( n * 64 );
    updateMenu = true;
  }

  public void updateHeight(int w) {
    totalHeight=0;
    for (AnchorImage a : aImages) {
      int thumbH = a.fitImageWidth(w);
      a.thumbH = thumbH;
      totalHeight+=thumbH;
    }
  }
}

public void controlEvent(ControlEvent theEvent) {
  // println("got a menu event from item : "+theEvent);
}
int randomTimes = 50;

public void buildButtons() {
  cp5.addButton("addFolder")
    //.setBroadcast(false);
    .setPosition(0, 0)
    .setSize(100, 50)
    .setCaptionLabel("\ue145");
  ;
  cp5.addButton("preview")
    //.setBroadcast(false);
    .setPosition(100, 0)
    .setSize(100, 50)
    .setCaptionLabel("\ue5d5");
  ;
  cp5.addToggle("recRandom")
    //.setBroadcast(false);
    .setPosition(200, 0)
    .setSize(100, 50)
    .setLabel("\ue037")
    .getCaptionLabel().align(ControlP5.CENTER, ControlP5.CENTER)
    ;
  cp5.addToggle("rec")
    //.setBroadcast(false);
    .setPosition(300, 0)
    .setSize(100, 50)
    .setCaptionLabel("\ue064")
    .getCaptionLabel().align(ControlP5.CENTER, ControlP5.CENTER)
    ;
  cp5.addButton("saveCurrent")
    //.setBroadcast(false);
    .setPosition(400, 0)
    .setSize(100, 50)
    .setLabel("\ue5db")
    //  .getCaptionLabel().align(ControlP5.CENTER, ControlP5.CENTER)
    ;
  cp5.addButton("clearJoints")
    //.setBroadcast(false);
    .setPosition(width-200, 0)
    .setSize(200, 50)
    .setCaptionLabel("\ue5cd");
  ;
  cp5.addButton("saveButton")
    //.setBroadcast(false);
    .setPosition(width-200, height-50)
    .setSize(100, 50)
    .setFont(font)
    .setCaptionLabel("SAVE");
  ;
  cp5.addButton("loadButton")
    //.setBroadcast(false);
    .setPosition(width-100, height-50)
    .setSize(100, 50)
    .setFont(font)
    .setCaptionLabel("LOAD");
  ;
}
boolean recRandom = false;
boolean rec = false;
boolean saveFolderExist = false;

public void recRandom(boolean theFlag) {
  recRandom = theFlag;
  if ( theFlag ) {
    cp5.getController("rec").setLock(true);
    saveToFolder();
  } else {
    cp5.getController("rec").setLock(false);
    saveFolderExist = false;
  }
  println(recRandom);
  //saveToFolder();
}

public void saveCurrent() {
  if (GLOBAL_render) {
    buffer.save(RandomStringUtils.randomNumeric(8)+".png");
  }
}

public void clearJoints() {
  if (GLOBAL_selectedAnchorImage != null && !GLOBAL_render ) {
    GLOBAL_selectedAnchorImage.joints.clear();
    browser.updateMenu();
  }
}

public void preview() {
  //GLOBAL_selectedAnchorImage = null;
  browser.deselectAll();
  browser.updateMenu();
  build(pick());
  println("g "+GLOBAL_selectedSet);
}



public void build( ArrayList<AnchorImage> pickmap ) {
  ArrayList<Joint> baseJoints; 
  Joint pj, j;
  int bjx=-1;
  int bjy=-1;
  randomGenerator = new Random();
  if (imageSets.size() > 1) {
    //ArrayList<AnchorImage> pickmap = pick();
    AnchorImage pa, a;
    int dx = 0;
    int dy = 0;
    GLOBAL_render = true;
    drawBuffer.clear();

    AnchorImage base = pickmap.get(0);
    drawBuffer.add (  new AnchorImage( base.img, base.posx, base.posy) );
    //  buffer.image( base.img, base.posx, base.posy);
    for ( int i = 1; i< imageSets.size(); i++ ) {
      pa = pickmap.get(i-1);
      a = pickmap.get(i);
      // CommonId commonID = findCommonJoint(pa, a);
      CommonId commonID = findCommonJointDeep(a, pickmap);
      if (commonID.c2 >-1) {
        pa = pickmap.get(commonID.baseIndex);
        pj = pa.joints.get(commonID.c1);
        j = a.joints.get(commonID.c2);
        dx = j.x - pj.x - pa.posx;
        dy = j.y - pj.y - pa.posy;
        a.posx = -1*dx;
        a.posy = -1*dy;
      }
      // buffer.image( a.img, a.posx, a.posy);
      drawBuffer.add( new AnchorImage( a.img, a.posx, a.posy ));
      //println ("common id: "+commonID.c1 +" "+commonID.c2);
      // buffer.image( pa.img, pa.posx, pa.posy);
      // buffer.image( a.img, a.posx, a.posy);
    }
    renderBuffer();
    // buffer.endDraw();
    //println ("common id: "+commonID.c1 +" "+commonID.c2);
  }
}


public void rec(boolean theFlag) {
  rec = theFlag;
  if (theFlag) {
    cp5.getController("recRandom").setLock(true);
    buildUnqPickmaps();
    println("uniq nu "+combs.size());
    saveToFolder();
  } else {
    cp5.getController("recRandom").setLock(false);
    GLOBAL_startRecord=-1;
    combs.clear();
    pickMaps.clear();
  }
}

public void saveToFolder() {
  selectFolder("Select a folder to process:", "folderSaveSelected");
}

public void folderSaveSelected(File selection) {
  if (selection == null) {
    println("Window was closed or the user hit cancel.");
  } else {
    saveFolder = selection.getAbsolutePath();
    saveFolderExist = true;
    if (rec) {
      GLOBAL_startRecord = combs.size()-1;
    } 
    //File imgsdir = new File(folder);
    // for (ArrayList<AnchorImage> pmap : combs) {
    //  build(pmap);
    // buffer.save(RandomStringUtils.randomNumeric(8)+".png");
    // }
  }
}

ArrayList<ArrayList<AnchorImage>> pickMaps = new ArrayList<ArrayList<AnchorImage>>();
ArrayList<ArrayList<AnchorImage>> combs = new ArrayList<ArrayList<AnchorImage>>();
AnchorImage[] comb;

public void buildUnqPickmaps() {
  pickMaps.clear();
  combs.clear();
  for (ImageSet iSet : imageSets) {
    pickMaps.add( iSet.aImages );
  }
  comb = new AnchorImage[pickMaps.size()];
  generateUniques(0);
}

public void generateUniques(int pos) {
  if (pos == comb.length)
    combs.add(new ArrayList<AnchorImage>(Arrays.asList(comb)));
  else {
    ArrayList<AnchorImage> arr = pickMaps.get(pos);
    for (AnchorImage el : arr) {
      comb[pos] = el;
      generateUniques(pos + 1);
    }
  }
}

//ArrayList<AnchorImage> pickmap = new ArrayList<AnchorImage>();

public ArrayList<AnchorImage> pick() {
  ArrayList<AnchorImage> pickmap = new ArrayList<AnchorImage>();
  randomGenerator = new Random();
  pickmap.clear();
  if (imageSets.size() > 0) {
    for (ImageSet iSet : imageSets) {
      pickmap.add ( getRandom(iSet) );
    }
  }
  return pickmap;
}


public CommonId findCommonJointDeep( AnchorImage stem, ArrayList<AnchorImage> pickmap) {
  int startIndex = pickmap.indexOf(stem);
  CommonId idFound = new CommonId();
  idFound.c1 = -1;
  idFound.c2 = -1;
  for ( int i = startIndex-1; i >=0; i-- ) {
    AnchorImage base = pickmap.get(i);
    if (base.joints.size() >0 &&  stem.joints.size() >0 ) {
      for (Joint baseJoint : base.joints) {
        for (Joint stemJoint : stem.joints) {
          if ( baseJoint.id == stemJoint.id ) {
            idFound.c1 = base.joints.indexOf(baseJoint);
            idFound.c2 = stem.joints.indexOf(stemJoint);
            idFound.baseIndex = pickmap.indexOf(base);
            break;
          }
        }
      }
    }
  }
  //println ("common id deep: "+idFound.c1 +" "+idFound.c2+" "+idFound.baseIndex);
  return idFound;
}


public AnchorImage getRandom( ImageSet imgset ) {
  int index = randomGenerator.nextInt(imgset.aImages.size());
  AnchorImage ai = imgset.aImages.get(index);
  return ai;
}

public void addFolder() {
  selectFolder("Select a folder to process:", "folderSelected");
}

public void folderSelected(File selection) {
  if (selection == null) {
    println("Window was closed or the user hit cancel.");
  } else {
    String folder = selection.getAbsolutePath();
    File imgsdir = new File(folder);
    println("User selected " + folder);
    String[] extensions = new String[] { "tga", "jpg", "png" };
    List<File> files = (List<File>) FileUtils.listFiles(imgsdir, extensions, false);
    if (files.size() >0 ) {
      printArray(files);
      println("Found "+files.size()+" images in folder " +folder);
      ImageSet is = new ImageSet( files, selection.getName() );
      is.absFolderName = folder;
      imageSets.add( is );
      dOrder.add(imageSets.size()-1);
      updateDrawOrder();
    } else { 
      println("WARNING - no Images in folder " +folder);
    }
  }
}
class ImageSet {
  ArrayList<AnchorImage> aImages; 
  boolean selected = false;
  String folderName;
  String absFolderName;
  int drawOrder = -1;

  ImageSet( List<File> files, String _folder ) {
    aImages = new ArrayList<AnchorImage>();
    folderName = _folder;
    // List<File> files=  loadImagesFolder(_folder);
    for (int i = 0; i < files.size(); i++) {
      aImages.add(new AnchorImage( loadImage( files.get(i).getAbsolutePath() ) ) );
    }
    setBrowser.updateMenu();
  }
}

class AnchorImage {
  ArrayList<Joint> joints; 
  PImage img;
  int thumbW, thumbH;
  boolean selected = false;
  int posx = 0;
  int posy = 0;
  int drawOrder;

  AnchorImage(PImage _img) {
    img = _img;
    joints = new ArrayList<Joint>();
  }

  AnchorImage(PImage _img , int x , int y) {
    img = _img;
    posx = x;
    posy = y;
  }

  public int hasJoint(int _id) {
    int has = -1;
    for (Joint a : joints) {
      if (a.id == _id) {
        has = joints.indexOf(a);
        break;
      }
    }
    return has;
  }

  public int fitImageWidth(int new_width) {
    int w, h, new_height;
    w = img.width;
    h = img.height;
    new_height = h;
    float ratio = w/h;

    if ( w > new_width ) {
      new_height = (new_width * h) / w;
    }

    //if (new_height > bound_height) {
    //  //scale height to fit instead
    //  new_height = bound_height;
    //  //scale width to maintain aspect ratio
    //  new_width = (new_height * original_width) / original_height;
    //}
    return new_height;
  }
}

class Anchor {
  String name;
  int x;
  int y;
  Anchor(int _x, int _y, String _name) {
    name = _name;
    x=_x;
    y=_y;
  }
}
class Joint {
  int x = -1;
  int y = -1;
  int c;
  boolean selected = false;
  String name;
  int id;

  Joint( int _id) {
    id = _id;
  }


  Joint( int _id, int _c) {
    c=_c;
    id = _id;
  }

  Joint(String _name, int _c, int _id) {
    name = _name;
    c=_c;
    id = _id;
  }

  public void setXY(int _x, int _y) {
    x =_x;
    y = _y;
  }
}

public void addJointList() {
  joints.add( new Joint("Green", 0xff7ebf29, 0) );
  joints.add( new Joint("Teal", 0xff2bffce, 1) );
  joints.add( new Joint("Orange", 0xffff9f32, 2) );
  joints.add( new Joint("Purple", 0xffcf6fff, 3) );
  joints.add( new Joint("Red", 0xffe85107, 4) );
  joints.add( new Joint("Yellow", 0xffffe04f, 5) );
  joints.add( new Joint("Blue", 0xff6259ff, 6) );
  joints.add( new Joint("Grey", 0xff919191, 7) );
  joints.add( new Joint("Black", 0xff000000, 8) );
}

class JointList extends Controller<JointList> {
  ArrayList<Joint> setImages; 
  float pos, npos;
  int itemHeight = 50;
  int scrollerLength = 40;
  PGraphics menu;
  boolean updateMenu;
  int totalHeight=0;
  int w, h;
  int btSize = 50;

  JointList(ControlP5 c, String theName, int theWidth, int theHeight, ArrayList<Joint> _setImages) {
    super( c, theName, 0, 0, theWidth, theHeight );
    c.register( this );
    w = theWidth;
    setImages = _setImages;
    updateHeight(theWidth);
    menu = createGraphics(getWidth(), getHeight() );
    setView(new ControllerView<JointList>() {
      public void display(PGraphics pg, JointList t ) {
        if (updateMenu) {
          updateMenu();
        }
        if (inside() ) {
          menu.beginDraw();
          //int len = -(itemHeight * items.size()) + getHeight();
          //int ty = int(map(pos, len, 0, getHeight() - scrollerLength - 2, 2 ) );
          // menu.rect(getWidth()-4, ty, 4, scrollerLength );
          menu.endDraw();
        }
        pg.image(menu, 0, 0);
      }
    }
    );
    updateMenu();
  }

  public void updateMenu() {
    int len = -(totalHeight) + getHeight();
    npos = constrain(npos, len, 0);
    if (totalHeight < getHeight() ) {
      pos = 0;
    } else {
      pos += (npos - pos) * 0.1f;
    }
    if (inside() && setImages.size() > 0) {
      int len2 = itemHeight * setImages.size();
      int index = PApplet.parseInt( map( getPointer().y() - pos, 0, len2, 0, setImages.size() ) ) ;
      drawNormal();
      if (index < setImages.size() ) {
        drawOver(index);
      }
    } else {
      drawNormal();
    }
    updateMenu = abs(npos-pos)>0.01f ? true:false;
  }

  public void drawOver(int index) {
    int mX = getPointer().x();
    menu.beginDraw();
    menu.pushMatrix();
    menu.translate( 0, itemHeight *index );
    menu.pushMatrix();
    menu.textFont(iconFont);
    menu.textSize(21);
    menu.textAlign(CENTER, CENTER);

    menu.popMatrix();
    menu.popMatrix();
    menu.endDraw();
  }

  public void drawNormal() {
    menu.beginDraw();
    menu.pushMatrix();
    menu.translate( 0, pos );
    menu.pushMatrix();
    menu.noStroke();
    menu.background(240);
    menu.textAlign(LEFT);
    for (Joint a : setImages) {
      if (a.selected) {
        menu.fill(a.c);
        menu.rect(0, 0, w, itemHeight-1);
        menu.textFont(iconFont);
        menu.textAlign(CENTER, CENTER);
        menu.fill(255);
        menu.textSize(21);
        menu.text("\ue836", btSize/2, btSize/2-2);
        menu.textAlign(LEFT);
        menu.textFont(font);
        menu.textSize(16);
        menu.fill(255);
        menu.text(a.name, 48, 28);
      } else {
        menu.fill(255);
        menu.rect(0, 0, w, itemHeight-1);
        //menu.textAlign(CENTER);
        menu.textFont(iconFont);
        menu.textAlign(CENTER, CENTER);
        menu.fill(a.c);
        menu.textSize(21);
        menu.text("\ue836", btSize/2, btSize/2-2);
        menu.textAlign(LEFT);
        menu.textFont(font);
        menu.textSize(16);
        menu.fill(0);
        menu.text(a.name, 48, 29);
      }
      menu.translate(0, itemHeight);
    }
    menu.popMatrix();
    menu.popMatrix();
    menu.endDraw();
  }

  public void onMove() {
    updateMenu = true;
  }

  public void onEnter() {
    updateMenu = true;
  }

  public void onLeave() {
    updateMenu = true;
  }

  public void onRelease() {
    int len = itemHeight * setImages.size();
    int index = PApplet.parseInt( map( getPointer().y() - pos, 0, len, 0, setImages.size() ) ) ;
    if (index < setImages.size() ) {
      Joint s = setImages.get(index);
      for (Joint a : setImages) {
        a.selected=false;
        s.selected=true;
      }
      GLOBAL_joint = index;
      updateMenu = true;
    }
    println(GLOBAL_joint);
  }

  public void onDrag() {
    npos += getPointer().dy() * 2;
    updateMenu = true;
  } 

  public void onScroll(int n) {
    npos += ( n * 4 );
    updateMenu = true;
  }

  public void updateHeight(int w) {
    totalHeight = itemHeight * setImages.size();
  }
}
public void keyPressed() {
  if (key == ']') {
    moveItem( GLOBAL_selectedSet, imageSets, true );
    browser.updateMenu();
  } else if (key == '[') {
    moveItem( GLOBAL_selectedSet, imageSets, false );
    browser.updateMenu();
  } else if (key >= '0' && key <= '9') {
    if (GLOBAL_selectedSet != -1 ) {
      int t = (int)(key - '0');
      if ( t < dOrder.size() ) {
        autoUpdateDrawOrder(t);
      }
    }
  } else if (key == 's') {
    saveCreate();
  } else if (key == 'l') {
    loadSave();
  }
}

public void moveItem(int s, ArrayList<?> list, boolean up) {
  if (up && list.size() >  s+1) {
    Collections.swap(list, s, s+1);
    GLOBAL_selectedSet++;
  }
  if (!up && s-1 >= 0) {
    Collections.swap(list, s, s-1);
    GLOBAL_selectedSet--;
  }
}



public void moveItemList(int sourceIndex, int targetIndex, List<?> list) {
  if (sourceIndex <= targetIndex) {
    Collections.rotate(list.subList(sourceIndex, targetIndex + 1), -1);
  } else {
    Collections.rotate(list.subList(targetIndex, sourceIndex + 1), 1);
  }
}
ArrayList<AnchorImage> drawBuffer = new ArrayList<AnchorImage>();

public void renderBuffer() {
  ArrayList<AnchorImage> b = new ArrayList<AnchorImage>();

  //Collections.swap(drawBuffer, 2, 0);
  buffer.beginDraw();
  buffer.clear();
  buffer.pushMatrix();
  buffer.translate( (buffer_w-view_w)/2, (buffer_h-view_h)/2 );

  if (GLOBAL_startRecord <0 ) {
    buffer.background(255);
  }
  for (int i = 0; i<dOrder.size(); i++) {
    AnchorImage a = drawBuffer.get( dOrder.indexOf(i) );
    buffer.image( a.img, a.posx, a.posy);
  }
  buffer.popMatrix();
  buffer.endDraw();
}

public void autoUpdateDrawOrder(int t) {
  updateDrawOrder();
  int sIndex = dOrder.indexOf(imageSets.get(GLOBAL_selectedSet).drawOrder);
  int tIndex = dOrder.indexOf(t);
  println("pressed: "+t+" "+sIndex+" -> "+tIndex);
  Collections.swap(dOrder, sIndex, tIndex);
  //moveItemList(sIndex, t, dOrder);
  updateDrawOrder();
  printArray(dOrder);
}

public void updateDrawOrder() {
  for (int i = 0; i<imageSets.size(); i++) {
    imageSets.get(i).drawOrder = dOrder.get(i);
  }
}

public void resetDrawOrder() {
  dOrder.clear();
  for (int i = 0; i<imageSets.size(); i++) {
    dOrder.add(i);
    imageSets.get(i).drawOrder = i;
  }
}
PrintWriter output;

public void loadButton() {
  selectInput("Select a file to process:", "loadSelected");
}

public void saveButton() {
  selectOutput("Select a file to process:", "saveSelected");
}

public void saveSelected(File selection) {
  if (selection == null) {
    println("Window was closed or the user hit cancel.");
  } else {
    output = createWriter(selection.getAbsolutePath());
    output.print("SETS"+'\t');
    for (int i = 0; i<imageSets.size(); i++) {
      ImageSet set = imageSets.get(i);
      output.print(set.absFolderName+'\t');
    }
    output.print('\n');
    output.print("DORDER"+'\t');
    for (int i = 0; i<dOrder.size(); i++) {
      int d = dOrder.get(i);
      output.print(String.valueOf(d)+'\t');
    }
    output.print('\n');
    output.print("JOINTS"+'\t');
    for (int i = 0; i<imageSets.size(); i++) {
      ImageSet set = imageSets.get(i);
      for (int j=0; j<set.aImages.size(); j++) {
        AnchorImage ai = set.aImages.get(j);
        for (int k=0; k<ai.joints.size(); k++) {
          Joint jnt = ai.joints.get(k);
          // PATTERN = SET  ANCHORIMAGE  JOINT.ID JOINT.X JOINT.Y
          output.print(String.valueOf(i)+'\t'+String.valueOf(j)+'\t'+String.valueOf(jnt.id)+'\t'+String.valueOf(jnt.x)+'\t'+String.valueOf(jnt.y)+'\t');
        }
      }
    }
    output.flush(); // Writes the remaining data to the file
    output.close(); // Finishes the file
  }
}


public void loadSelected(File selection) {
  if (selection == null) {
    println("Window was closed or the user hit cancel.");
  } else {
    ArrayList<String> temp = new ArrayList<String>();
    // Open the file from the createWriter() example
    BufferedReader reader = createReader(selection.getAbsolutePath());
    String line = null;
    try {
      clearAll();
      while ((line = reader.readLine()) != null) {
        String[] pieces = split(line, TAB);
        String id = pieces[0];
        switch (id) {
        case "SETS":
          for ( int i=1; i<pieces.length-1; i++ ) {
            temp.add(pieces[i]);
          }
          for ( String s : temp ) {
            loatImageSets(s);
          }
          setBrowser.updateHeight();
          break;
        case "DORDER":
          dOrder.clear();
          for ( int i=1; i<pieces.length-1; i++ ) {
            dOrder.add(PApplet.parseInt(pieces[i]));
          }
          updateDrawOrder();
          break;
        case "JOINTS":
          for ( int i=1; i<pieces.length-1; i+=5 ) {
            ImageSet set = imageSets.get( PApplet.parseInt(pieces[i]) );
            AnchorImage img = set.aImages.get( PApplet.parseInt(pieces[i+1]) );
            Joint j = new Joint( PApplet.parseInt(pieces[i+2]), joints.get( PApplet.parseInt(pieces[i+2]) ).c );
            j.setXY( PApplet.parseInt(pieces[i+3]), PApplet.parseInt(pieces[i+4]) );
            img.joints.add(j);
          }
          break;
        }
      }
      reader.close();
      printArray( temp );
    } 
    catch (IOException e) {
      e.printStackTrace();
    }
  }
}


public void saveCreate() {
  output = createWriter("save.txt");
  output.print("SETS"+'\t');
  for (int i = 0; i<imageSets.size(); i++) {
    ImageSet set = imageSets.get(i);
    output.print(set.absFolderName+'\t');
  }
  output.print('\n');
  output.print("DORDER"+'\t');
  for (int i = 0; i<dOrder.size(); i++) {
    int d = dOrder.get(i);
    output.print(String.valueOf(d)+'\t');
  }
  output.print('\n');
  output.print("JOINTS"+'\t');
  for (int i = 0; i<imageSets.size(); i++) {
    ImageSet set = imageSets.get(i);
    for (int j=0; j<set.aImages.size(); j++) {
      AnchorImage ai = set.aImages.get(j);
      for (int k=0; k<ai.joints.size(); k++) {
        Joint jnt = ai.joints.get(k);
        // PATTERN = SET  ANCHORIMAGE  JOINT.ID JOINT.X JOINT.Y
        output.print(String.valueOf(i)+'\t'+String.valueOf(j)+'\t'+String.valueOf(jnt.id)+'\t'+String.valueOf(jnt.x)+'\t'+String.valueOf(jnt.y)+'\t');
      }
    }
  }
  output.flush(); // Writes the remaining data to the file
  output.close(); // Finishes the file
}

public void loadSave() {
  ArrayList<String> temp = new ArrayList<String>();
  // Open the file from the createWriter() example
  BufferedReader reader = createReader("save.txt");
  String line = null;
  try {
    clearAll();
    while ((line = reader.readLine()) != null) {
      String[] pieces = split(line, TAB);
      String id = pieces[0];
      switch (id) {
      case "SETS":
        for ( int i=1; i<pieces.length-1; i++ ) {
          temp.add(pieces[i]);
        }
        for ( String s : temp ) {
          loatImageSets(s);
        }
        setBrowser.updateHeight();
        break;
      case "DORDER":
        dOrder.clear();
        for ( int i=1; i<pieces.length-1; i++ ) {
          dOrder.add(PApplet.parseInt(pieces[i]));
        }
        updateDrawOrder();
        break;
      case "JOINTS":
        for ( int i=1; i<pieces.length-1; i+=5 ) {
          ImageSet set = imageSets.get( PApplet.parseInt(pieces[i]) );
          AnchorImage img = set.aImages.get( PApplet.parseInt(pieces[i+1]) );
          Joint j = new Joint( PApplet.parseInt(pieces[i+2]), joints.get( PApplet.parseInt(pieces[i+2]) ).c );
          j.setXY( PApplet.parseInt(pieces[i+3]), PApplet.parseInt(pieces[i+4]) );
          img.joints.add(j);
        }
        break;
      }
    }
    reader.close();
    printArray( temp );
  } 
  catch (IOException e) {
    e.printStackTrace();
  }
} 

public void clearAll() {
  browser.deselectAll();
  setBrowser.deselectAll();
  imageSets.clear();
  //joints.clear();
  dOrder.clear();
}

public void loatImageSets(String folder) {
  //String folder = selection.getAbsolutePath();
  File imgsdir = new File(folder);
  String[] extensions = new String[] { "tga", "jpg", "png" };
  List<File> files = (List<File>) FileUtils.listFiles(imgsdir, extensions, false);
  if (files.size() >0 ) {
    ImageSet is = new ImageSet( files, imgsdir.getName() );
    is.absFolderName = folder;
    imageSets.add( is );
    dOrder.add(imageSets.size()-1);
    updateDrawOrder();
  }
}
class CustomList extends Controller<CustomList> {
  ArrayList<ImageSet> setImages; 
  float pos, npos;
  int itemHeight = 50;
  int scrollerLength = 40;
  PGraphics menu;
  boolean updateMenu;
  int totalHeight=0;
  int w, h;
  int btSize = 50;

  CustomList(ControlP5 c, String theName, int theWidth, int theHeight, ArrayList<ImageSet> _setImages) {
    super( c, theName, 0, 0, theWidth, theHeight );
    c.register( this );
    w = theWidth;
    setImages = _setImages;
    updateHeight();
    menu = createGraphics(getWidth(), getHeight() );
    setView(new ControllerView<CustomList>() {
      public void display(PGraphics pg, CustomList t ) {
        if (updateMenu) {
          updateMenu();
        }
        if (inside() ) {
          menu.beginDraw();
          //int len = -(itemHeight * items.size()) + getHeight();
          //int ty = int(map(pos, len, 0, getHeight() - scrollerLength - 2, 2 ) );
          // menu.rect(getWidth()-4, ty, 4, scrollerLength );
          menu.endDraw();
        }
        pg.image(menu, 0, 0);
      }
    }
    );
    updateMenu();
  }

  public void updateMenu() {
    int len = -(totalHeight) + getHeight();
    npos = constrain(npos, len, 0);
    if (totalHeight < getHeight() ) {
      pos = 0;
    } else {
      pos += (npos - pos) * 0.1f;
    }
    if (inside() && setImages.size() > 0) {
      int len2 = itemHeight * setImages.size();
      int index = PApplet.parseInt( map( getPointer().y() - pos, 0, len2, 0, setImages.size() ) ) ;
      drawNormal();
      if (index < setImages.size() ) {
        drawOver(index);
      }
    } else {
      drawNormal();
    }
    updateMenu = abs(npos-pos)>0.01f ? true:false;
  }

  public void drawOver(int index) {
    int mX = getPointer().x();
    menu.beginDraw();
    menu.pushMatrix();
    menu.translate( 0, itemHeight *index );
    menu.pushMatrix();
    menu.textFont(iconFont);
    menu.textSize(21);
    menu.textAlign(CENTER, CENTER);
    if ( mX < w-btSize) {
      menu.fill(0, 50);
      menu.text("\ue5cd", w-btSize/2, btSize/2-2);
      //  menu.text("\ue838", w-btSize-btSize/2, btSize/2-2);
    } /*else if ( mX >= w-2*btSize && mX <w-btSize) {
     menu.fill(126, 191, 41);
     menu.rect(w-2*btSize, 0, btSize, itemHeight-1);
     menu.fill(255);
     menu.text("\ue838", w-btSize-btSize/2, btSize/2-2);
     menu.fill(0, 50);
     menu.text("\ue5cd", w-btSize/2, btSize/2-2);
     }*/
    else {
      menu.fill(255, 0, 0);
      menu.rect(w-btSize, 0, btSize, itemHeight-1);
      menu.fill(255);
      menu.text("\ue5cd", w-btSize/2, btSize/2-2);
    }
    //menu.fill(230);
    //menu.rect(w-100, 0, 50, itemHeight-1);
    //menu.fill(200);
    //menu.textSize(24);
    //menu.text("▲", w-82, 32); 
    menu.popMatrix();
    menu.popMatrix();
    menu.endDraw();
  }

  public void drawNormal() {
    menu.beginDraw();
    menu.pushMatrix();
    menu.translate( 0, pos );
    menu.pushMatrix();
    menu.noStroke();
    menu.background(240);
    menu.textAlign(LEFT);
    for (ImageSet a : setImages) {
      if (a.selected) {
        menu.fill(255, 255, 155);
      } else {
        menu.fill(255);
      }
      menu.rect(0, 0, w, itemHeight-1);
      //menu.textAlign(CENTER);
      menu.textFont(font);
      menu.textSize(16);
      menu.fill(255, 0, 0);
      menu.text(( (a.drawOrder == -1) ? "" : a.drawOrder )+"", 18, 29);
      menu.fill(0);
      menu.text(a.folderName, 40, 29);

      menu.translate(0, itemHeight);
    }
    menu.popMatrix();
    menu.popMatrix();
    menu.endDraw();
  }

  public void onMove() {
    updateMenu = true;
  }

  public void onEnter() {
    updateMenu = true;
  }

  public void onLeave() {
    updateMenu = true;
  }

  public void onRelease() {
    int len = itemHeight * setImages.size();
    int index = PApplet.parseInt( map( getPointer().y() - pos, 0, len, 0, setImages.size() ) ) ;
    if (index < setImages.size() ) {
      ImageSet s = setImages.get(index);
      if ( getPointer().x() < w-50 ) {
        if (s.selected) {
          s.selected=false;
          GLOBAL_selectedSet =-1;
          GLOBAL_selectedAnchorImage=null;
          browser.updateSource(empty);
        } else {
          for (ImageSet a : setImages) {
            a.selected=false;
            s.selected=true;
          }
          GLOBAL_selectedSet = index;
          browser.updateSource(s.aImages);
          updateMenu = true;
        }
      } else {
        //dOrder.remove( setImages.indexOf(s) );
        setImages.remove(s);
        //updateDrawOrder();
        GLOBAL_selectedSet =-1;
        browser.updateSource(empty);
        resetDrawOrder();
      }
    }
    println(GLOBAL_selectedSet);
  }

  public void deselectAll() {
    for (ImageSet a : setImages) {
      a.selected=false;
      GLOBAL_selectedSet =-1;
      GLOBAL_selectedAnchorImage=null;
      browser.updateSource(empty);
    }
  }

  public void onDrag() {
    npos += getPointer().dy() * 2;
    updateMenu = true;
  } 

  public void onScroll(int n) {
    npos -= ( n * 64 );
    updateMenu = true;
  }

  public void updateHeight() {
    totalHeight = itemHeight * setImages.size();
  }
}
public List<File> loadImagesFolder(String folder) {
  File imgsdir = new File(sketchPath() + "/"+folder);
  String[] extensions = new String[] { "tga", "jpg", "png" };
  List<File> files = (List<File>) FileUtils.listFiles(imgsdir, extensions, true);
  if (files.size() >0 ) {
    println("Found "+files.size()+" images in folder " +folder);
    for (int i = 0; i < files.size(); i++) {
      // imgBrushes[i] = new Imagebrush(files.get(i));
    }
  } else { 
    println("WARNING - no Images in folder " +folder);
  }
  return files;

  /*
  filename = f.getName();
   extension = FilenameUtils.getExtension(filename);
   abs_path = f.getAbsolutePath();
   */
}

class CommonId {
  int c1;
  int c2;
  int baseIndex;
  CommonId () {
  }
}


public List<String> combineTwoLists(List<String> list1, List<String>   list2) {
  List<String> result = new ArrayList<String>();
  StringBuilder sb = new StringBuilder();
  for (String s1 : list1)
  {
    for (String s2 : list2)
    {
      sb.setLength(0);
      sb.append(s1).append(' ').append(s2);
      result.add(sb.toString());
    }
  }
  return result;
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "Variations_RC5" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
