import org.apache.commons.io.FilenameUtils;
import java.util.*;
import controlP5.*;
import java.util.Random;
import java.util.Arrays;
import java.util.List;
import org.apache.commons.lang3.RandomStringUtils;

ControlP5 cp5;
MenuList browser;
CustomList setBrowser;
JointList jointList;
PGraphics renderPanel, buffer;
//PGraphics2D controlPanel;
PFont font, iconFont;
Random randomGenerator;

ArrayList<AnchorImage> empty;
ArrayList<ImageSet> imageSets = new ArrayList<ImageSet>();
ArrayList<Joint> joints =  new ArrayList<Joint>();
ArrayList<Integer> dOrder =  new ArrayList<Integer>();
AnchorImage GLOBAL_selectedAnchorImage = null;
int GLOBAL_selectedSet=-1;
int GLOBAL_joint=-1;
boolean GLOBAL_render = false;
int GLOBAL_startRecord = -1;
String saveFolder;

int view_w; 
int view_h;
int buffer_w; 
int buffer_h;

void settings() {

  view_w = 1080;
  view_h = 1080;
  buffer_w = 1080;
  buffer_h = 1080;

  size(view_w+700, view_h);
  // smooth(4);
}

void setup() {
  buffer =  createGraphics(buffer_w, buffer_h);
  renderPanel = createGraphics(view_w, view_h);
  renderPanel.ellipseMode(CENTER);
  renderPanel.beginDraw();
  renderPanel.background(255);
  renderPanel.endDraw();
  //renderPanel.smooth(4);
  background(240);
  cp5 = new ControlP5( this );
  font = createFont("SourceCodePro-Regular.ttf", 18, true);
  iconFont = createFont("icomoon.ttf", 21, true);
  cp5.setFont(new ControlFont(iconFont));

  setBrowser = new CustomList( cp5, "setBrowser", 300, height-50, imageSets );
  setBrowser.setPosition(0, 50);

  buildButtons();

  //ImageSet def = new ImageSet( loadImagesFolder("legs"), "legs" );
  //def.absFolderName = "D:\\Dropbox\\Processing_new\\Variations_RC5\\legs";
  //imageSets.add( def );
  //dOrder.add(imageSets.size()-1);

  //def = new ImageSet( loadImagesFolder("body"), "body" );
  //def.absFolderName = "D:\\Dropbox\\Processing_new\\Variations_RC5\\body";
  //imageSets.add( def );
  //dOrder.add(imageSets.size()-1);

  //def = new ImageSet( loadImagesFolder("head"), "head" );
  //def.absFolderName = "D:\\Dropbox\\Processing_new\\Variations_RC5\\head";
  //imageSets.add( def );
  //dOrder.add(imageSets.size()-1);

  updateDrawOrder();


  empty = new ArrayList<AnchorImage>();
  browser = new MenuList( cp5, "browser", 200, height-50, empty );
  browser.setPosition(300, 50);

  addJointList();
  jointList = new JointList( cp5, "jointlist", 200, height-100, joints );
  jointList.setPosition(width-200, 50);
}

void mouseReleased() {
  if (GLOBAL_joint>-1 && GLOBAL_selectedAnchorImage != null) {
    if (mouseX > 500 && mouseX < width-200) {
      Joint j = joints.get(GLOBAL_joint);
      Joint newJoint; 
      int jid = GLOBAL_selectedAnchorImage.hasJoint(j.id);
      if  ( jid > -1 ) {
        newJoint = GLOBAL_selectedAnchorImage.joints.get(jid);
        newJoint.setXY(mouseX-500, mouseY);
      } else {
        newJoint= new Joint(j.id, j.c);
        newJoint.setXY(mouseX-500, mouseY);
        GLOBAL_selectedAnchorImage.joints.add(newJoint);
      }
      browser.updateMenu();
    }
  }
}

void draw() {
  setBrowser.updateMenu();
  background(240);
  String txt_fps = String.format(getClass().getName()+ "  [fps %6.2f]", frameRate);
  surface.setTitle(txt_fps);
  renderPanel.beginDraw();
  renderPanel.background(255);
  if (GLOBAL_selectedAnchorImage != null && !GLOBAL_render ) {
    renderPanel.image(GLOBAL_selectedAnchorImage.img, 0, 0);
    for (Joint j : GLOBAL_selectedAnchorImage.joints) {
      renderPanel.noFill();
      renderPanel.stroke(j.c);
      renderPanel.strokeWeight(4);
      renderPanel.ellipse(j.x, j.y, 50, 50);
    }
  } else if (GLOBAL_startRecord >=0 ) {
    // for (ArrayList<AnchorImage> pmap : combs) {
    ArrayList<AnchorImage> pmap = combs.get(GLOBAL_startRecord);
    build(pmap);
    buffer.save(saveFolder+"/"+RandomStringUtils.randomNumeric(8)+".png");
    GLOBAL_startRecord--;
    renderPanel.fill(0);
    renderPanel.textSize(32);
    renderPanel.textAlign(CENTER, CENTER);
    renderPanel.text(GLOBAL_startRecord+" remaining", view_w/2, view_h/2);
  } else if (recRandom && saveFolderExist) {
    preview();
    renderPanel.image(buffer, 0, 0, view_w, view_h);
    buffer.save(saveFolder+"/"+RandomStringUtils.randomNumeric(8)+".png");
  } else {
    renderPanel.image(buffer, 0, 0, view_w, view_h);
  }
  renderPanel.endDraw();
  image(renderPanel, 500, 0, view_w, view_h);
}
